//************************************************************************
// AVRPROM Blankcheck
//
// Holger Klabunde
// 12.10.2002
// Compiler Visual C++ V5.0
//************************************************************************
#include "stdafx.h"

#include "Global.h"
#include "protos.h"
#include "port_io.h"
#include "spi_io.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int CAVRPromDlg::BlankCheck()
{
 int result;
 unsigned char be;
 unsigned int buff;
 unsigned long counter;

 ResetProgress(maxadr);

 switch(program_mode)
  {
   case SPI1: case MSPI1:
   break;
   default: Msg("Programmiermodus fehlt in BlanckCheck()");
    return NO_BLANK;
   break;
  }

/*
 result=ShowBox("LEERTEST");
 if(result==IDCANCEL) return NO_VERIFY;
*/

 m_Cancel.EnableWindow(TRUE); //Cancel-Knopf aktivieren
 m_Message.SetWindowText("Leertest Programmspeicher");
 UpdateWindow();

 if(checkid>0)
  {
   if(CheckID()!=NO_ERRORS)
    {
	 return NO_BLANK;
	}
  }

//******************************
//Beginn Datenspeicher auslesen
//******************************
 counter=0;

 result=NO_ERRORS;

 do
  {
    if(program_mode>=SPI1)
     {
      buff=SPIReadAVRWord(counter); //s.o.
     }

	if(buff!=0xFFFF)
	 {
	  sprintf(zeile,"Programmspeicher \n"
					"Blank Check Fehler an\n"
					"Adresse %lu\n"
					"Wort 0xFFFF\n"
					"Gelesen 0x%04X"
				 ,counter,buff);
	  result=MsgRetryCancel(zeile);
	 }

	counter++; // nchstes Byte

	UpdateProgress();

 }while((counter<maxadr)&&(result!=IDCANCEL)&&(mCancel==FALSE));
//Ende Blankcheck Programmemory

//Dann das Daten EEPROM
 if((result!=IDCANCEL)&&(mCancel==FALSE)&&(maxeepadr>0)) //Wenn oben nicht abgebrochen
  {
   counter=0;
   ResetProgress(maxeepadr);
   m_Message.SetWindowText("Leertest DatenEEPROM");
   UpdateWindow();

   do
    {

     if(program_mode>=SPI1)
      {
       be=SPIReadAVRByte(counter); //s.o.
      }

	  if(be!=0xFF)
	   {
	    sprintf(zeile,"Daten EEPROM\n"
					  "Blank Check Fehler\n"
					  "Adresse %lu\n"
					  "Byte 0xFF\n"
					  "Gelesen 0x%02X"
				 ,counter,be);
	    result=MsgRetryCancel(zeile);
	   }

	  counter++; // nchstes Byte

	  UpdateProgress();

   }while((counter<maxeepadr)&&(result!=IDCANCEL)&&(mCancel==FALSE));

  }
//Ende Blankcheck Datamemory

 m_Percent.SetPos(0); //Statusanzeige zurcksetzen

 if(result==IDCANCEL) return NO_BLANK; //Abbruch wegen Fehler
 if(mCancel==TRUE)
  {
   Msg("Leertest abgebrochen !"); //Abbruch ber Cancel-Knopf
   return NO_BLANK;
  }

 return result;
}
