//************************************************************************
// Versucht die Art einer HEX-Datei zu ermitteln
//
// Erkennt folgende Formate in 8 und 16 Bit:
// Intel8MDS		  16Bit
// IntelMCS86		  20Bit nein
// Intel32			  32Bit
// Motorola Exorciser 16Bit S1 HEX
// Motorola Exormax   24Bit S2 HEX
// Motorola 		  32Bit S3 HEX
//
// Das ROM-Format vom Atmel AVR-Assembler 8 und 16 Bit
//
// Alle anderen werden erstmal als BINR abgestempelt
//
// Epromer 8.xx
// Holger Klabunde
// 06.09.2001
// Compiler Visual C++ V5.0
//************************************************************************
#include "stdafx.h"

#include "Global.h"
#include "protos.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int CAVRPromDlg::CheckHex(char *fname,int mode)
{
 char *n;
 int count,i,submode;

 hexmode=UNKNOWN_HEX; //Mu neu bestimmt werden

//Datei ffnen
 if((in=fopen(fname,"rt"))==NULL) //Als ASCII Text ffnen
  {
   if(mode==16) { ShowErr(fname); return UNKNOWN_HEX; } //Keine Programmdaten
   if(mode==8) { return UNKNOWN_HEX; } //Keine EEPROMdaten, raus ohne Meldung
  }

 count=0;
 do
  {
	n=fgets(line,ARRAYSIZE,in); //Eine Zeile lesen
	if(n!=NULL) //Zeile gelesen
	 {

      //Mal sehen ob nur ASCII-Zeichen enthalten sind
	  for(i=0; i<(int)(strlen(line)-2); i++) //-2 wegen CR+LF
	   { if((line[i]>0x7F)||(line[i]<0x20)) hexmode=BIN; } //kein Standard-ASCII

	  if(hexmode!=BIN) //War wohl keine reine ASCII Zeile
	   {

        if(line[4]==':') //Dann ersma AtmelAVRAssembler-ROM-Format
		 {
	      if(strlen(line)==8)
		   {
		    hexmode=ATMEL_AVR;  // 8 Bit Daten
			submode=8; //kurz merken fr unten
           }
		 }

        if(line[6]==':') //Dann ersma AtmelAVRAssembler-ROM-Format
		 {
		  if(strlen(line)==12)
		   {
		    hexmode=ATMEL_AVR; //16 Bit Daten
			submode=16; //kurz merken fr unten
           }
		 }

	    if(line[0]==':') //Intel Hex
		 {
		  if(line[8]=='0') hexmode=INTEL8; //Intel8MDS 16Bit
		  if(line[8]=='4') hexmode=INTEL32; //Intel8MDS 16Bit

		  if(line[8]=='2')
		   {
			hexmode=INTELMCS; // 20Bit ersma bis zweite Zeile geprft
			n=fgets(line,ARRAYSIZE,in); //Zweite Zeile lesen
			if(n!=NULL)
			 {
			  if(line[8]=='4') hexmode=INTEL32; //Intel 32 Bit HEX
			  //Sonst bleibt es bei INTELMCS
		     }
  		    else hexmode=UNKNOWN_HEX;
		   } 

		 }//if line[0]==':';


	    if(line[0]=='S') //Motorola Hex
		{
		 if(line[1]=='1') hexmode=MOT_S1; //16Bit
		 if(line[1]=='2') hexmode=MOT_S2; //24Bit
		 if(line[1]=='3') hexmode=MOT_S3; //32Bit
		}
       
	   }//if hexmode!=BIN

	 } //if n!=NULL

	count++;
  }while((n!=NULL)&&(hexmode==UNKNOWN_HEX)&&(count<LASTHEXLINE));

 if(hexmode==UNKNOWN_HEX) hexmode=BIN; //Keine HEX-Datei, dann Binrdaten

 if(in) fclose(in);
 in=NULL; //Besser is das
 return hexmode;
}

//Diese Routine befreit die gelesene HEX-Zeile von
//CR+LF am Ende der Zeile
//In einer HEX-Datei wurden Spaces am Ende eingefgt damit
//alle Zeilen dieselbe Lnge haben. Das haben die alten Routinen
//nicht gefressen !
int CAVRPromDlg::ClearHexString(char *st, int maxlen)
{
 int i;
 char by;

 for(i=0; i<maxlen; i++) //Puffergrenze nicht berschreiten !
  {
   by=st[i];
   if(by==0x0D) { st[i]=0; break; } //CR
   if(by==0x0A) { st[i]=0; break; } //LF
   if(by==' ')  { st[i]=0; break; } //ein Leerzeichen !
  }

 return 0;
}
