//************************************************************************
// ERASE.C
// Lschen des ganzen Bausteines in einem Schritt
//
// Avrpromer V1.10
// Holger Klabunde
// 03.10.2002
// Compiler Visual C++ V5.0
//************************************************************************
#include "stdafx.h"

#include "Global.h"
#include "protos.h"
#include "port_io.h"
#include "ftd2def.h"
#include "spi_io.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Lschroutine.
int CAVRPromDlg::EraseAVR()
{
 int result;

 switch(program_mode)
  {
   case SPI1: case MSPI1:
   break;
   default: Msg("Programmiermodus fehlt in EraseAVR()");
    return NO_BLANK;
   break;
  }

 result=ShowBox("BAUSTEIN LSCHEN !!");
 if(result==IDCANCEL) return NO_ERASE;

 result=NO_ERRORS;

//Nachsehen ob es der gewnschte Baustein ist
 if(checkid>0)
  {
   if(CheckID()!=NO_ERRORS)
    {
	 return NO_ERASE;
	}
  }

//Wichtig ?? Vorm Lschen RC-Cal lesen und Warnung !
/*
 if(device==MEGA163) //Mega163
  {
   by=SPIReadRCCal();
   sprintf(zeile,"Diesen Wert bitte unter dem Chip notieren !\n\n"
                 "RC-Calibration-Wert %02X\n",by);
   Msg(zeile);
  }
*/

 result=Erase(); //Hier wird endlich gelscht

 if(result!=NO_ERRORS) return NO_ERASE;

 return NO_ERRORS;
}

//Eigentliche Lschroutine
int CAVRPromDlg::Erase()
{
 int result;

 switch(program_mode)
  {
   case SPI1: case MSPI1:
   break;
   default: Msg("Programmiermodus fehlt in Erase()");
    return NO_BLANK;
   break;
  }

 result=NO_ERRORS;
 m_Message.SetWindowText("Lsche Baustein");

 if(program_mode>=SPI1)
  {
   SPIWrite(SPI_ERASE1); //Commando Erase Teil1 senden
   SPIWrite(SPI_ERASE2); //Commando Erase Teil2 senden
   SPIWrite(DONTCARE);   //Pseudocode senden, wird nicht benutzt
   SPIWrite(DONTCARE);   //Pseudocode senden, wird nicht benutzt
   FlushUSB();  
   Wait1ms(erasetime); //Lschzeit abwarten

   RESET_ON();
   Wait1ms(RESETTIME);
   RESET_OFF(); 
   Wait1ms(RESETTIME);
   RESET_ON();
   Wait1ms(RESETTIME);
   RESET_OFF(); 
   Wait1ms(RESETTIME);
 
   SPISync();
  }

 return result;
}