//************************************************************************
// Avrprom fr EPROMER V8.xx
// Liest die Daten in den Datenpuffer
// Die Datei mu vorher geffnet worden sein !
// Holger Klabunde
// 17.20.2001
// Compiler Visual C++ V5.0
//************************************************************************
#include "stdafx.h"

#include "Global.h"
#include "protos.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int CAVRPromDlg::FillBuffer(int hexmode, int mode)
{
 int result;
 unsigned long i;

 m_Message.SetWindowText("Lese Daten");
 UpdateWindow();

 for(i=0; i<BLOCKSIZE; i++) data[i]=0xFF; //Datenpuffer lschen 

 highadr=0;  //Hchste gefundene Adresse der Hex-Datei
 linecount=0; //Zeilenzhler fr HEX-Datein
 offset=0;    //Offset aus Intel-HEX

 //Ab hier die HEX-Dateien lesen
 if(hexmode!=BIN)
  {
   do
	{
     switch(hexmode)
	  {
	   case INTEL8:	   result=ReadIntelHex(); break;
	   case INTEL32:   result=ReadIntelHex(); break;
	   case INTELMCS:  result=ReadIntelHex(); break;
	   case MOT_S1:	   result=ReadS123Hex(); break;
	   case MOT_S2:	   result=ReadS123Hex(); break;
	   case MOT_S3:	   result=ReadS123Hex(); break;
	   case ATMEL_AVR: result=ReadROMHex(mode); break;
	  }

     //Lesen bis Dateiende oder bis Fehler auftreten
	}while((result!=NO_INPUT)&&(result!=END_HEX));

   if(result==END_HEX) result=NO_ERRORS; //Flag alles ok
  } //if hexmode!=BIN

 if(hexmode==BIN)
  {
   result=ReadBlockBin(BLOCKSIZE,mode); //Binrdatei lesen
  }

 if(result!=NO_ERRORS) return result; //Lesen nicht erfolgreich

//Check ob Daten bzw. Dateigre ok sind
 if(highadr==0)
  {
   Msg("Dateilnge ist NULL !\n\nDie Datei enthlt keine Daten !");
   return NO_INPUT;
  }

 if(mode==8)
  {

   if(highadr>=maxeepadr) //Byte Daten
    {
     sprintf(zeile,"Zuviele EEPROM-Daten fr diesen Baustein !\n\n"
                 "Erlaubt: 0x%lX\n"
                 "Gelesen: 0x%lX\n"
				 ,maxeepadr,highadr+1);
	 Msg(zeile);
	 return NO_INPUT;
	}
  }

 if(mode==16)
  {
   if((highadr/2)>=maxadr) //Word Daten
    {
     sprintf(zeile,"Zuviele Programmdaten fr diesen Baustein !\n\n"
                 "Erlaubt: 0x%lX\n"
				 "Gelesen: 0x%lX"
                 ,maxadr,(highadr+1)/2);
	 Msg(zeile);
	 return NO_INPUT;
	}
  }
//Ende-Check ob Daten bzw. Dateigre ok sind

 return NO_ERRORS; //Alles ok
}
