//Meine Definitionen

#ifndef GLOBAL_H
#define GLOBAL_H

#include "AVRPROMDlg.h"

//Name des Hauptfensters
const char mytitle[]="AVR/ATiny/ATMega ISP-Prommer V3.06";

//Name des Teufelchens, und Kennzeichen um festzustellen
//ob der Brenner gerade aktiv ist
const char deviltitle[]="MultipromDevil";

//MULTIPRO.INI Eintrge
const char MYSECTION[]="AVRProm INI-Section";
const char ALL[]="Hardware";
const char WAITING[]="Warte auf Eingaben";
const char SAVING[]="Speichere Bausteindaten";

const char filter[]="*.* Alle Dateien|*.*|"
                    "*.BIN Binr-Dateien|*.bin|"
                    "*.ROM Atmel AVR Assembler|*.rom|"
					"*.HEX Hex-Dateien|*.hex||";
const char filtersave[]="*.* Alle Dateien|*.*|"
						"*.BIN Binr|*.bin|"
						"*.ROM;*.EEP Atmel AVR-Assembler|*.rom;*.eep|"
						"*.HEX Intel8|*.hex|"
						"*.HEX Intel32|*.hex|"
						"*.HEX IntelMCS|*.hex|"
						"*.HEX Motorola S1 Exorciser|*.hex|"
						"*.HEX Motorola S2 Exormax|*.hex|"
						"*.HEX Motorola S3 32Bit|*.hex|"
						"|"; //Ende der Filter

const char meld[]="Meldung";

#define LASTHEXLINE  2	//Zeile bis zu der das HEX-Format bestimmt sein mu

//HEX-Modi
enum { UNKNOWN_HEX,
       BIN,
	   ATMEL_AVR,
	   INTEL8, INTEL32,
	   INTELMCS,
       MOT_S1, MOT_S2, MOT_S3,
	   LASTHEX
	  };

#define BLOCKSIZE 65536*4	//Lese und Schreibpuffergre in Bytes

#define RANGE	  50	//Anzahl Schritte fr Progressindikator
#define ARRAYSIZE 1024  //Gre fr alle Textarrays

#define MAXLOCKBITS 2  //Maximale Anzahl Lockbits bisher


//Programmiermodi
enum { UNKNOWN_MODE,
	   SPI1,          //Single Word Write
	   MSPI1          //Page Write
	 };

#define S1200	0x9001
#define S2313	0x9101
#define S2323	0x9102
#define S2343	0x9103
#define S4414	0x9201
#define S8515	0x9301
#define S2333	0x9105
#define S4433	0x9203
#define S4434	0x9202
#define S8535	0x9303
#define TINY12	0x9005
#define TINY13	0x9007
#define TINY15	0x9006
#define TINY22	0x9103 //wie S2343 !
#define TINY25		0x9108
#define TINY26		0x9109
#define TINY45		0x9206
#define TINY85		0x930B
#define TINY2313	0x910A
#define TINY26	0x9109
#define MEGA103	0x9701
#define MEGA161 0x9401
#define MEGA162 0x9404
#define MEGA163 0x9402
#define MEGA165		0x9407
#define MEGA168	0x9406
#define MEGA169 0x9405
#define MEGA603 0x9601
#define MEGA8	0x9307
#define MEGA16	0x9403
#define MEGA323	0x9501
#define MEGA32	0x9502
#define MEGA325		0x9503	//Auch ATMega 329
#define MEGA3250	0x9504	//Auch ATMega 3290
#define MEGA48	0x9205
#define MEGA64	0x9602
#define MEGA640		0x9607
#define MEGA644		0x9609
#define MEGA645		0x9603	//Auch ATMega 649
#define MEGA6450	0x9604	//Auch ATMega 6490
#define MEGA88	0x930A
#define MEGA128	0x9702
#define MEGA1280	0x9703
#define MEGA1281	0x9704
#define MEGA2560	0x9801
#define MEGA2561	0x9802
#define MEGA8515 0x9306
#define MEGA8535 0x9308
#define AT90PWM2	0x9381	//Auch AT90PWM3
#define AT90CAN128	0x9781

enum { UNKNOWN_OS, WIN_95, WIN_98, WIN_ME
      , WIN_NT351, WIN_NT4, WIN_2000, WIN_XP, WIN_SERVER2003 };

#define MINTIME 100	//Minimale PIC-Timer Auflsung 100us

#define MESSAGE_NO   0  //Meldung beim Verify unterdrcken
#define MESSAGE_YES  1

//Return Fehlercodes
#define NO_ERRORS 	0 // Keine Fehler aufgetreten
#define NO_MEMORY 	1 // Kein Speicher mehr
#define NO_INI    	2 // Ini Datei nicht geffnet
#define NO_INPUT  	3 // Konnte Eingabedatei nicht ffnen
#define NO_OUTPUT	4 // Konnte Ausgabedatei nicht ffnen
#define NO_BLANK	5 // EPROM nicht leer
#define NO_VERIFY	6 // Verify Fehler oder EPROM fehlt
#define NO_BURN		7 // EPROM konnte nicht gebrannt werden
#define NO_TESTOK 	8 // Brenner nicht gefunden
#define NO_TIMER	9 // Timer reagiert nicht
#define NO_PIC		10 // PIC reagiert nicht
#define END_HEX		11 // Ende einer HEX-Datei
#define HEADER_ONLY	12 // Nur Header Zeile bei S1,S2,S3 Hex-Dateien
#define NO_CSV		13 // Datei SERLIST.csv nicht geffnet
#define NO_ID		14 // ID's des Prozessors falsch
#define NO_NAME	    17 // Name in Herstellerdatei nicht gefunden
#define NO_ERASE	18 // Baustein konnte nicht gelscht werden
#define NO_DATA     19 // Bausteindaten nicht ok

//Borland C++ Befehle
// outportb(int adr,unsigned char byte);
// inportb(int adr);
// durch VisualC++ Befehle per Makro ersetzen
// int _outp( unsigned short port, int databyte );
// int _inp( unsigned short port );

#define outportb(a,b) _outp((unsigned short)(a),(int)(b));
#define inportb(a) (unsigned char)_inp((unsigned short)(a));

#endif //GLOBAL_H