//************************************************************************
// MESSAGES.C
// Gibt allgemeine Meldungen aus
// AVRPROM V2.xx
//
// Holger Klabunde
// 03.10.2002
// Compiler Visual C++ V5.0
//************************************************************************
#include "stdafx.h"

#include <direct.h>

#include "Global.h"
#include "protos.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Identifications-Record der S2,S3 Dateien
void CAVRPromDlg::NoIdentRecord()
{
 Msg("Identifikations-Record der HEX-Datei\n"
	 "konnte nicht geschrieben werden.");
 Showerror();
 if(out!=NULL) fclose(out);
 out=NULL;
}

//Letzter Record konnte nicht geschrieben werden
void CAVRPromDlg::NoEndHex()
{
 Msg("Endemarkierung der HEX-Datei\n"
	 "konnte nicht geschrieben werden.");
 Showerror();
 if(out!=NULL) fclose(out);
 out=NULL;
}

//Header der Datei nicht geschrieben
void CAVRPromDlg::NoHexHeader()
{
 Msg("Header-Record der HEX-Datei\nkonnte nicht geschrieben werden.");
 Showerror();
 if(out!=NULL) fclose(out);
 out=NULL;
}

//Fehlermeldung beim speichern
void CAVRPromDlg::NoHexLine()
{
 Msg("Hex-Zeile konnte nicht geschrieben werden");
}

//Wie die Meldung schon sagt
void CAVRPromDlg::ErrorReadHex()
{
 Msg("Fehler beim Lesen der Hex-Datei !");
}

//Hex-Zeile belegt doppelt ein Speicherzelle
void CAVRPromDlg::BadHex()
{
 sprintf(zeile,"Eine oder mehrere Speicherzellen werden\n"
     "in dieser HEX-Datei doppelt belegt !\n\n"
	 "Gefunden in Zeile %ld\n"
	 ,linecount	);
 Msg(zeile);
}

//Falsche Hex-Zeilenlnge
void CAVRPromDlg::WrongHexLineLen(unsigned long red, unsigned long added)
{
 sprintf(zeile,"Lnge der HEX-Zeile %lu stimmt nicht !\n\n"
					"Gelesen %lu\nBerechnet %lu\n"
					,linecount,red,added);
 Msg(zeile);
}

//Anfang der HEX-Zeile fehlt
void CAVRPromDlg::NoLineBegin()
{
 sprintf(zeile,"Zeilenanfang in Zeile %lu\nder Hex-Datei nicht gefunden !"
				 ,linecount);
 Msg(zeile);
}

//Falsche Prfsumme in einer HEX-Zeile
void CAVRPromDlg::BadChecksum(unsigned int ch1,unsigned int ch2)
{
 sprintf(zeile,"Prfsumme der HEX-Zeile %lu stimmt nicht !\n\n"
					"Gelesen 0x%04X\nBerechnet 0x%04X\n",linecount,ch1,ch2);
 Msg(zeile);
}

int CAVRPromDlg::ShowBox(char *message)
{
 int result;
 strcpy(zeile,"*** ");
 strcat(zeile,devicename);
 strcat(zeile," ***\n\n");
 strcat(zeile,message);

 result=MsgOkCancel(zeile);
 return result;
}
