//************************************************************************
// Speichert den Inhalt des AVR in einer Atmel Assembler ROM Datei
//
// AVRPROM V2.xx
//
// Holger Klabunde
// 03.10.2002
// Compiler Visual C++ V5.0
//************************************************************************
#include "stdafx.h"

#include "Global.h"
#include "protos.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// FILE *out ist ein Zeiger auf die vorher geffnete Datei
// dat 	Byte oder Word Daten, je nach mode
// adr  Reale Adresse im AVR
// empty Maske fr Leerzellen. Leerzellen beim Speichern weglassen !

int CAVRPromDlg::SaveROMHex(char *fname, int mode, unsigned long topmem)
{
 int result;
 unsigned long be,blank,saved,adr;

 switch(program_mode)
  {
   case SPI1: case MSPI1:
   break;
   default: Msg("Programmiermodus fehlt in SaveROMHex()");
    return NO_BLANK;
   break;
  }

 adr=0;

 if(mode==8) blank=0xFF; //Byte Wert fr eine Leerzelle
 if(mode==16) blank=0xFFFF; //Word Wert fr eine Leerzelle

 result=NO_ERRORS; //Bis hier ersma richtig

//HEX-Datei als Textdatei ffnen
 if((out=fopen(fname,"w+t"))==NULL)
  { ShowErr(fname); return NO_OUTPUT; }

 do
  {
   if(mode==8)
    {
     if(program_mode>=SPI1)
      {
       be=SPIReadAVRByte(adr); //s.o.
      }

     sprintf(zeile,"%04lX:%02lX\n",adr,be);
    }


   if(mode==16) //3 Byte Adresse und 2 Byte Word Daten schreiben
    {
     if(program_mode>=SPI1)
      {
       be=SPIReadAVRWord(adr); //s.o.
      }

     sprintf(zeile,"%06lX:%04lX\n",adr,be);
    }

   if(mCancel==FALSE)
    {
     if(be!=blank) //Leerzellen nicht speichern
      {
       saved=fwrite(zeile,strlen(zeile),1,out); //Schreiben
       if(saved==0)
	    {
		 NoHexLine();
		 ShowErr(fname);
		 result=NO_OUTPUT;
		}
      }
     else
      {

       if(no_ff>0) //Leerzellen doch speichern
        {
         saved=fwrite(zeile,strlen(zeile),1,out); //Schreiben
         if(saved==0)
		  {
		    NoHexLine();
			ShowErr(fname);
		    result=NO_OUTPUT;
		  }
 	    }

      }
    }

  adr++;

  UpdateProgress();

 }while((adr<topmem)&&(mCancel==FALSE)&&(result==NO_ERRORS));


//Hexdatei schlieen
 if(out!=NULL) { fclose(out); out=NULL; }
 if(result==NO_OUTPUT) return NO_OUTPUT;

 return NO_ERRORS;
}
