//************************************************************************
// AVR auslesen und sichern in einer HEX Datei
//
// Holger Klabunde
// 03.10.2002
// Compiler Visual C++ V5.0
//************************************************************************
#include "stdafx.h"

#include "Global.h"
#include "protos.h"
#include "port_io.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Speichert den Inhalt in einer Hex-Datei
int CAVRPromDlg::SaveHex(char *fname, int mode, unsigned long topmem)
{
 unsigned long datcounter; //Arrayindexzhler
 unsigned long firstblockadr; //Startadresse des letzten Blocks
 unsigned long ok,ok1;        //Hilfsvariablen
 unsigned long checksum,be,counter;
 unsigned char check;

 switch(program_mode)
  {
   case SPI1: case MSPI1:
   break;
   default: Msg("Programmiermodus fehlt in SaveHex()");
    return NO_BLANK;
   break;
  }

//Als Hex-Ascii-Datei ffnen
 if((out=fopen(fname,"w+t"))==NULL)
  { ShowErr(fname); return NO_OUTPUT; }

 counter=0;

//*** Intel32 Header Zeilen ***
 //Der einzige Unterschied zum IntelMCS86 Format ist diese Zeile
 //Sie enthlt den Adressteil ber A19
 //Sie erscheint nur einmal am Anfang der HEX-Datei und enthlt
 //immer 0x0000 weil der Brenner nur Bausteine bis A19 untersttzt
 if(hexmode==INTEL32)
  {
   strcpy(zeile,":020000040000FA\n");

   //Offsetadresse Teil>A19 schreiben
   ok1=fwrite(zeile,strlen(zeile),1,out);
   if(ok1==0) //Fehler, mu eins sein
	{ NoHexHeader(); return NO_OUTPUT; }
  }//if hexmode==INTEL32
//*** Ende Intel32 Header Zeilen ***

//*** Motorola S-Record Header Zeilen ***
 if((hexmode==MOT_S1)||(hexmode==MOT_S2)||(hexmode==MOT_S3))
  {
   //Header Record fr S1,2,3 enthlt 'EPROMER 7.1'
   strcpy(zeile,"S00E00004550524F4D455220372E3121\n");
   ok1=fwrite(zeile,strlen(zeile),1,out); //Kennungsrecord schreiben
   if(ok1==0) //darf nicht 0 sein weil Daten da waren
	{ NoHexHeader(); return NO_OUTPUT; }
  }

 if((hexmode==MOT_S2)||(hexmode==MOT_S3))
  {
   //Identifizier Record fr S2
   if(hexmode==MOT_S2) strcpy(zeile,"S204000000FB\n");
   //Identifizier Record fr S3
   if(hexmode==MOT_S3) strcpy(zeile,"S305000000FA\n");
	
   ok1=fwrite(zeile,strlen(zeile),1,out);
   if(ok1==0) //darf nicht 0 sein weil Daten da waren
	{ NoIdentRecord(); return NO_OUTPUT; }
  }
//*** Ende Motorola S-Record Header Zeilen ***

//****************************************************
//Beginn schreiben Hex-Format mit linearem Adressraum
//****************************************************
 if((hexmode==INTEL8)||(hexmode==MOT_S1)||(hexmode==MOT_S2)||(hexmode==MOT_S3))
  {
   do
	{
	 if(mode==8) firstblockadr=counter; //Byte Daten
	 if(mode==16) firstblockadr=counter*2; //Word Daten

	 datcounter=0; //Array Indexzhler zurcksetzen
	 do
	  {
       if(mode==8)
	    {
         if(program_mode>=SPI1)
          {
           be=SPIReadAVRByte(counter); //s.o.
          }

	     data[datcounter]=(unsigned char)be; 	//Array fllen
	     datcounter++;				//nchstes Arrayelement
		}//if mode==8

       if(mode==16)
	    {
         if(program_mode>=SPI1)
          {
           be=SPIReadAVRWord(counter); //s.o.
          }

	     data[datcounter]=(unsigned char)(be&0xFF); 	//LowByte
	     datcounter++;			//nchstes Arrayelement
	     data[datcounter]=(unsigned char)((be>>8)&0xFF); //HighByte
	     datcounter++;			//nchstes Arrayelement
        }//if mode==16

	   counter++; 					// nchste Epromadresse

	   UpdateProgress();

	  }while((datcounter<BLOCKSIZE)&&(counter<topmem)&&(mCancel==FALSE));

    if(mCancel==FALSE)
	 {
	  switch(hexmode)
	   {
	    case INTEL8    : ok=WriteIntelHex(data,firstblockadr,datcounter);     break;
		case MOT_S1    : ok=WriteS123Hex(data,firstblockadr,datcounter);      break;
		case MOT_S2    : ok=WriteS123Hex(data,firstblockadr,datcounter);      break;
		case MOT_S3    : ok=WriteS123Hex(data,firstblockadr,datcounter);      break;
	   }
      // Fehlermeldung kam schon in WriteHex()
	  if(ok!=datcounter) { ShowErr(fname); }// Genaue Fehlermeldung
	 }

	}while((counter<topmem)&&(ok==datcounter)&&(mCancel==FALSE));
  }
//****************************************
//Ende HEX-Formate mit linearem Adressraum
//****************************************

//******************************************
//Beginn schreiben Intel32- und INTELMCS-Hex
//******************************************
 if((hexmode==INTEL32)||(hexmode==INTELMCS))
  {
   do
	{
     if(mode==8) //Byte Daten
	  {
	   checksum=0x02+0x02; //Anzahl Bytes und Zeilentyp
	   checksum+=(counter>>4)&0xFF; //LowByte der Adresse
	   checksum+=(counter>>12)&0xFF; //HighByte der Adresse
	   checksum=~checksum; //Einerkomplement
	   checksum++; //Zweierkomplement
	   check=(unsigned char)(checksum&0xFF); //Nur das Lowbyte

	   sprintf(zeile,":02000002%04lX%02X\n",(counter/16),check);
      }

     if(mode==16) //Word Daten, Adresse verdoppeln !!
	  {
	   checksum=0x02+0x02; //Anzahl Bytes und Zeilentyp
	   checksum+=((counter*2)>>4)&0xFF; //LowByte der Adresse
	   checksum+=((counter*2)>>12)&0xFF; //HighByte der Adresse
	   checksum=~checksum; //Einerkomplement
	   checksum++; //Zweierkomplement
	   check=(unsigned char)(checksum&0xFF); //Nur das Lowbyte

	   sprintf(zeile,":02000002%04lX%02X\n",((counter*2)/16),check);
      }

     //Offsetadresse schreiben
	 ok=fwrite(zeile,strlen(zeile),1,out);
	 if(ok==0)
	  {
	   datcounter=ok+1; //Bricht die Schleife unten ab !!!
	   ShowErr(fname);
	  } // Genaue Fehlermeldung
	 else
	  {
	   datcounter=0; //Array Indexzhler zurcksetzen

       //256 Byte Block lesen
	   do
		{

         if(mode==8)
	      {
           if(program_mode>=SPI1)
            {
             be=SPIReadAVRByte(counter); //s.o.
            }

	       data[datcounter]=(unsigned char)be; 	//Array fllen
	       datcounter++;				//nchstes Arrayelement
		  }

         if(mode==16)
	      {
           if(program_mode>=SPI1)
            {
             be=SPIReadAVRWord(counter); //s.o.
            }

	       data[datcounter]=(unsigned char)(be&0xFF); 	//LowByte
	       datcounter++;			//nchstes Arrayelement
	       data[datcounter]=(unsigned char)((be>>8)&0xFF); //HighByte
	       datcounter++;			//nchstes Arrayelement
          }

		 counter++; 					// nchste Epromadresse

		 UpdateProgress();

		}while((datcounter<256)&&(counter<topmem)&&(mCancel==FALSE));

		if(mCancel==FALSE)
		 {
		  //256 Byte Block schreiben
	      ok=WriteIntelHex(data,0x00,datcounter);//Array schreiben
          // Fehlermeldung kam schon in WriteHex()
	      if(ok!=datcounter) { ShowErr(fname); }// Genaue Fehlermeldung
		 }
	  }

	}while((counter<topmem)&&(ok==datcounter)&&(mCancel==FALSE));
  }
//******************************************
//Ende schreiben Intel32- und INTELMCS-Hex
//******************************************

 if(mCancel==TRUE) //Abbruch durch Benutzer
  {
   if(out!=NULL) { fclose(out); out=NULL; }
   return NO_OUTPUT;
  }

 if(ok==datcounter) //Endekennung der Datei schreiben
  {
   //*** Motorola HEX-Formate ***
   if((hexmode==MOT_S1)||(hexmode==MOT_S2)||(hexmode==MOT_S3))
	{
     switch(hexmode)
	  {
       case MOT_S1: strcpy(zeile,"S9030000FC\n");     break;
       case MOT_S2: strcpy(zeile,"S804000000FB\n");   break;
       case MOT_S3: strcpy(zeile,"S70500000000FA\n"); break;
	  }
	 ok1=fwrite(zeile,strlen(zeile),1,out);
	 if(ok1==0) NoEndHex(); //darf nicht 0 sein weil Daten da waren
	}

   //*** Intel HEX-Formate ***
   if((hexmode==INTEL8)||(hexmode==INTELMCS)||(hexmode==INTEL32))
	{
     strcpy(zeile,":00000001FF\n");
	 ok1=fwrite(zeile,strlen(zeile),1,out);
	 if(ok1==0) NoEndHex(); //darf nicht 0 sein weil Daten da waren
	}

  }

 if(out!=NULL){ fclose(out);  out=NULL; }
 if((ok!=datcounter)||(ok1==0)) return NO_OUTPUT;

 return NO_ERRORS;
}
