//************************************************************************
// Definitionen fr das SPI Protokoll
// AVRPROM V2.00
// Holger Klabunde
// 03.10.2002
// Compiler Visual C++ V5.0
//************************************************************************

#ifndef SPI_IO_H //mehrfaches includen vermeiden
#define SPI_IO_H

//Bitmasken fr LPT SPI
#define ENABLE    0x01
#define SPIRESET  0x02
#define SPIIN	  0x04  //SPI schreiben
#define SPICLK	  0x08
#define SPIOUT	  SELECT  //SPI lesen

//Bitmasken fr USB SPI
//Hmm, nicht aufgepasst ;) Htte man an oben
//anpassen knnen.
#define USB_ENABLE    0x80  //Jetzt die LED   
#define USB_SPIRESET  0x20
#define USB_SPIIN	  0x08  //SPI schreiben
#define USB_SPICLK	  0x01
#define USB_SPIOUT	  0x02  //SPI lesen
#define USB_NLED      0x80  //LED invertiert

//#define XTAL1	  0x02

#define DONTCARE  0x00	//Fllbits fr Kommandoteile die nicht benutzt werden
#define RESETTIME 100   //Zeiten fr RESET
#define PROGENABLE 100  //Zeit nach SPI Program Enable

#define RESET_ON() { if(use_lpt) daten|=SPIRESET; \
                     if(use_usb) daten|=USB_SPIRESET; \
                     SendByte(DATEN,daten); }

#define RESET_OFF() { if(use_lpt) daten&=~SPIRESET; \
                      if(use_usb) daten&=~USB_SPIRESET; \
                      SendByte(DATEN,daten); }

#define SI_ON() { if(use_lpt) { daten|=SPIIN; SendByte(DATEN,daten); } \
                  if(use_usb) { daten|=USB_SPIIN; usbbuf[usbcount++]=daten; } \
                }

#define SI_OFF() { if(use_lpt) { daten&=~SPIIN; SendByte(DATEN,daten); } \
                   if(use_usb) { daten&=~USB_SPIIN; usbbuf[usbcount++]=daten; } \
                 }

#define SID_ON() { if(use_lpt) { daten|=SPIIN; } \
                  if(use_usb) { daten|=USB_SPIIN; } \
                }

#define SID_OFF() { if(use_lpt) { daten&=~SPIIN; } \
                   if(use_usb) { daten&=~USB_SPIIN; } \
                 }

//#define SO_ON() { daten|=SPIOUT; SendByte(DATEN,daten); }
//#define SO_OFF() { daten&=~SPIOUT; SendByte(DATEN,daten); }

//ISP Adapter ein/ausschalten 
#define ISP_ENABLE() { if(use_lpt) { daten=0x00; SendByte(DATEN,daten); } \
                       if(use_usb) { daten=0x00; \
                                     if(ftdll) \
                                      { \
                                       FT_SetBitMode(fthandle,(unsigned char)0xA9,(unsigned char)0x01); \
                                       FT_SetBaudRate(fthandle,usbbaudrate); \
                                       FT_SetLatencyTimer(fthandle,1); \
                                      } \
                                   } \
                     }

#define ISP_DISABLE() { if(use_lpt) { daten=ENABLE; SendByte(DATEN,daten); } \
                        if(use_usb) { if(ftdll) FT_SetBitMode(fthandle,(unsigned char)0x00,(unsigned char)0x00); } \
                      }

//#define XTAL1_ON() { daten|=XTAL1; SendByte(DATEN,daten); }
//#define XTAL1_OFF() { daten&=~XTAL1; SendByte(DATEN,daten); }

//#define X_CLOCK() { XTAL1_ON(); XTAL1_OFF(); };

//SPI Taktleitung
#define SCLK_ON() { if(use_lpt) { daten|=SPICLK; SendByte(DATEN,daten); } \
                    if(use_usb) { daten|=USB_SPICLK; usbbuf[usbcount++]=daten; } \
                  }

#define SCLK_OFF() { if(use_lpt) { daten&=~SPICLK; SendByte(DATEN,daten); } \
                     if(use_usb) { daten&=~USB_SPICLK; usbbuf[usbcount++]=daten; } \
                   }

//Kommandos
#define SPI_ENABLE_PROG1		0xAC //Zwei Byte Sequenz fr Enable Programming
#define SPI_ENABLE_PROG2		0x53
#define SPI_ERASE1				0xAC //Zwei Byte Sequenz fr Erase
#define SPI_ERASE2				0x80
#define SPI_READ_PROGRAM		0x20 //Programmspeicher lesen
#define SPI_WRITE_PROGRAM		0x40 //Programmspeicher schreiben
#define SPI_READ_EEPROM			0xA0 //Datenspeicher lesen
#define SPI_WRITE_EEPROM		0xC0 //Datenspeicher schreiben
#define SPI_READ_LOCK_FUSE		0x58 //Lockbits und Fuses lesen
#define SPI_READ_LOCK           0x58 //Nur Lockbits bei ATMega
#define SPI_READ_SIGN_1			0x30 //ID lesen
#define SPI_READ_SIGN_2			0x3F //In Vorbereitung auf neue Megas eingefhrt
#define SPI_READ_SIGN_3			0x1F //0001 1111 ATiny13
#define SPI_WRITE_LOCK_A		0xAC //Zwei Byte Sequenz fr Lockbits
#define SPI_WRITE_RCEN1			0xAC
#define SPI_WRITE_RCEN2			0xA1
#define SPI_WRITE_PAGE			0x4C //Page Program starten bei ATMega
#define SPI_LOAD_PAGE			0x40 //Page fllen bei ATMega
#define SPI_WRITE_FUSE			0xAC //Zwei Byte Sequenz fr Fusebits
#define SPI_READ_RCCAL			0x38 //0011 1000 ATiny13 read RC-Calibration
#define SPI_EXT_ADR_SET1		0x4D //0100 1101 ATMega 640,1280,1281,2560,2561 extended adress set
#define SPI_EXT_ADR_SET2		0x00 //0000 0000 ATMega 640,1280,1281,2560,2561 extended adress set

#endif