//************************************************************************
// Ermittelt die Windows-Version
// Holger Klabunde
// 12.04.2004
// Compiler Visual C++ V5.0
//************************************************************************
#include <windows.h>
#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <winsvc.h>
#include <direct.h>

#include "Global.h"
#include "protos.h"

// resource STRINGTABLE defines
#define OKAY						0
#define OKAY_START					1
#define OKAY_REMOVED					2
#define UNEXPECTED_ERROR				9999

SC_HANDLE hSCMan = NULL;

void GetServiceName(LPSTR, LPSTR);
DWORD DriverInstall(LPSTR, LPSTR);
DWORD DriverStart(LPSTR);
DWORD DriverStop(LPSTR);
DWORD DriverRemove(LPSTR);

//*************************************
int WindowsVersion()
//*************************************
{
 DWORD dwStatus = OKAY;
 char szPath[MAX_PATH], szDriver[MAX_PATH];
 OSVERSIONINFO osv;
 HANDLE h;
 CString WindowsPlatform;

 osv.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);

 winversion=UNKNOWN_OS; //System ersma unbekannt

if (GetVersionEx(&osv))
{

 // note: szCSDVersion =  service pack  release  
 CString ServiceRelease = osv.szCSDVersion;

 switch(osv.dwPlatformId)
  {

//  case VER_PLATFORM_WIN32s: //Win32s on Windows 3.1.
// WindowsPlatform = "Microsoft Windows 3.1(TM)";
// break;

  case VER_PLATFORM_WIN32_WINDOWS: //WIN32 on 95 or 98
   //determine if Win95, Win98 or ME
   if (osv.dwMajorVersion == 4 && osv.dwMinorVersion == 0)
    {
     if(ServiceRelease==" C ") ServiceRelease="OSR2";
     WindowsPlatform = "Microsoft Windows 95(TM) " + ServiceRelease;
     winversion=WIN_95;
    }

   if (osv.dwMajorVersion == 4 && osv.dwMinorVersion == 10)
    {
     if(ServiceRelease==" A ") ServiceRelease="Second Edition";
     WindowsPlatform = "Microsoft Windows 98(TM) " + ServiceRelease;
     winversion=WIN_98;
    }

   if (osv.dwMajorVersion == 4 && osv.dwMinorVersion == 90)
    {
     WindowsPlatform = "Microsoft Windows ME(TM) " + ServiceRelease;
     winversion=WIN_ME;
    }
  break;

  case VER_PLATFORM_WIN32_NT: //Win32 on Windows NT.
   if (osv.dwMajorVersion == 3 && osv.dwMinorVersion == 51)
    {
     WindowsPlatform = "Microsoft Windows NT3.51(TM) " + ServiceRelease;
     winversion=WIN_NT351;
    }
    
   if (osv.dwMajorVersion == 4 && osv.dwMinorVersion == 0)
    {
     WindowsPlatform = "Microsoft Windows NT4.00(TM) " + ServiceRelease;
     winversion=WIN_NT4;
    }

   if (osv.dwMajorVersion == 5 && osv.dwMinorVersion == 0)
    {
     WindowsPlatform = "Microsoft Windows 2000(TM) " + ServiceRelease;
     winversion=WIN_2000;
    }

   if (osv.dwMajorVersion == 5 && osv.dwMinorVersion == 1)
    {
     WindowsPlatform = "Microsoft Windows XP(TM) " + ServiceRelease;
     winversion=WIN_XP;
    }

   if (osv.dwMajorVersion == 5 && osv.dwMinorVersion == 2)
    {
     WindowsPlatform = "Microsoft Windows Server 2003(TM) " + ServiceRelease;
     winversion=WIN_SERVER2003;
    }

 
//*************************************************************
// Giveio.sys als Hardwaretreiber laden
//*************************************************************
   h = CreateFile("\\\\.\\giveio", GENERIC_READ, 0, NULL,
  				  OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
   if(h == INVALID_HANDLE_VALUE)
    { 
     // connect to local service control manager
     if ((hSCMan = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS)) == NULL) 
      {
       AfxMessageBox("Keine Verbindung zum ServiceControlManager mglich.\n\n"
                     "Der 'giveio.sys' Treiber kann nicht von Usern installiert werden.\n\n"
                     "Das kann nur der Administrator !\n\n"
                     "Dieses Programm bitte einmal als Administrator starten.\n"
                     "Danach ist der Treiber installiert und das Programm\n"
                     "kann auch von Usern benutzt werden.\n"
                     ,MB_OK);
       return NO_BURN;
      }

     GetServiceName(szPath, szDriver); //build service name
     dwStatus = DriverInstall(szPath, szDriver);

     //service installed or not ? in both cases if not running start it
/*
     if(debugnt)
      {
       if(dwStatus==OKAY)
        {
         AfxMessageBox("'giveio.sys' Driver installed !",MB_OK);
        }

       if(dwStatus==ERROR_SERVICE_NOT_ACTIVE)
        {
         AfxMessageBox("Driver installed but not started !\n"
                       "We will try to do this now.",MB_OK);
        }
      }
*/

     //Start the installed driver
     dwStatus = DriverStart(szDriver);
     //   if(debugnt && dwStatus!=OKAY) AfxMessageBox("Driver not started !",MB_OK);
//     if(debugnt && dwStatus==ERROR_SERVICE_ALREADY_RUNNING) AfxMessageBox("'giveio.sys' Driver already started !",MB_OK);
//     if(debugnt && dwStatus==ERROR_SERVICE_NOT_ACTIVE) AfxMessageBox("'giveio.sys' Driver has not been started !",MB_OK);
//     if(debugnt && dwStatus==OKAY) AfxMessageBox("'giveio.sys' Driver started !",MB_OK);

     h = CreateFile("\\\\.\\giveio", GENERIC_READ, 0, NULL,
	  				  OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
      if(h == INVALID_HANDLE_VALUE)
	   {
        AfxMessageBox("'giveio.sys' Devicetreiber konnte nicht geladen werden\n", MB_OK);
       }
      else CloseHandle(h);
    } //if(h == INVALID_HANDLE_VALUE)  
   else CloseHandle(h);
//*************************************************************
// Ende Giveio.sys als Hardwaretreiber laden
//*************************************************************
  break;

  default: AfxMessageBox("Operating System nicht erkannt !", MB_OK);
    winversion=UNKNOWN_OS;
  break;

 } //end switch

// if(debugnt) AfxMessageBox(WindowsPlatform, MB_OK);  

} //end if (GetVersionEx(&osv))

 return NO_ERRORS;
}

//##############################################################
DWORD DriverInstall(LPSTR lpPath, LPSTR lpDriver)
//##############################################################
{
   BOOL dwStatus = OKAY;
   SC_HANDLE hService = NULL;

//#define SERVICE_BOOT_START             0x00000000 // Fehler bei NT4.0
//#define SERVICE_SYSTEM_START           0x00000001
//#define SERVICE_AUTO_START             0x00000002
//#define SERVICE_DEMAND_START           0x00000003
//#define SERVICE_DISABLED               0x00000004

   // add to service control manager's database
  if(winversion<WIN_XP) //this is for WIN_NT351,NT4,W2k
      hService = CreateService(hSCMan, lpDriver, lpDriver, SERVICE_ALL_ACCESS,
                               SERVICE_KERNEL_DRIVER,
                               SERVICE_AUTO_START,
                               SERVICE_ERROR_NORMAL, lpPath, 
                               NULL, NULL, NULL, NULL, NULL);

  if(winversion>=WIN_XP) //this is for WIN_XP, Server 2003
      hService = CreateService(hSCMan, lpDriver, lpDriver, SERVICE_ALL_ACCESS,
                               SERVICE_KERNEL_DRIVER,
                               SERVICE_SYSTEM_START,
                               SERVICE_ERROR_NORMAL, lpPath, 
                               NULL, NULL, NULL, NULL, NULL);

   if (hService == NULL)
      dwStatus = GetLastError();
   else
     CloseServiceHandle(hService);

   return dwStatus;
} // DriverInstall

//##############################################################
void GetServiceName(LPSTR lpPath, LPSTR lpDriver)
//##############################################################
{
 char mybuf[MAX_PATH];

 strcpy(mybuf,"giveio.sys");
 _splitpath(mybuf, NULL, NULL, lpDriver, NULL);

 _getcwd(lpPath, MAX_PATH); //get current directory
 strcat(lpPath,"\\");
 strcat(lpPath,mybuf);
} // GetServiceName

//##############################################################
DWORD DriverStart(LPSTR lpDriver)
//##############################################################
{
   BOOL dwStatus = OKAY;
   SC_HANDLE hService = NULL;

   // get a handle to the service
   if ((hService = OpenService(hSCMan, lpDriver, 
      SERVICE_ALL_ACCESS)) != NULL) 
   {
      // start the driver
      if (!StartService(hService, 0, NULL))
         dwStatus = GetLastError();
   } else dwStatus = GetLastError();

   if (hService != NULL) CloseServiceHandle(hService);
   return dwStatus;
} // DriverStart

//##############################################################
DWORD DriverStop(LPSTR lpDriver)
//##############################################################
{
   BOOL dwStatus = OKAY;
   SC_HANDLE hService = NULL;
   SERVICE_STATUS serviceStatus;

   // get a handle to the service
   if ((hService = OpenService(hSCMan, lpDriver, 
      SERVICE_ALL_ACCESS)) != NULL) 
   {
      // stop the driver
      if (!ControlService(hService, SERVICE_CONTROL_STOP,
         &serviceStatus))
            dwStatus = GetLastError();
   } else dwStatus = GetLastError();

   if (hService != NULL) CloseServiceHandle(hService);
   return dwStatus;
} // DriverStop

//##############################################################
DWORD DriverRemove(LPSTR lpDriver)
//##############################################################
{
   BOOL dwStatus = OKAY;
   SC_HANDLE hService = NULL;

   // get a handle to the service
   if ((hService = OpenService(hSCMan, lpDriver, 
      SERVICE_ALL_ACCESS)) != NULL) 
   {
      // remove the driver
      if (!DeleteService(hService))
         dwStatus = GetLastError();
   } else dwStatus = GetLastError();

   if (hService != NULL) CloseServiceHandle(hService);
   return dwStatus;
} // DriverRemove
