//************************************************************************
// Auslesen und sichern in einer
// Motorola S1 HEX Datei mit 16Bit Adressierung
// Motorola S2 HEX Datei mit 24Bit Adressierung
// Motorola S3 HEX Datei mit 32Bit Adressierung
// AVRPROM V1.xx fr Epromer V8.xx
//
// Holger Klabunde
// 13.01.1999
// Compiler Visual C++ V5.0
//************************************************************************
#include "stdafx.h"

#include "Global.h"
#include "protos.h"
#include "port_io.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Speichert ein Datenarray mit 8 Bit Daten in einer S3 HEX Datei
// Die vorher geffnet wurde FILE *out ist der Zeiger auf die Datei
unsigned long CAVRPromDlg::WriteS123Hex(unsigned char *dat,unsigned long start,unsigned long len)
{
 int result;		  //Fr fwrite()
 unsigned long adr; //Realer Adresszhler
 unsigned long datadr; //Adresszhler des Arrays
 unsigned long rest;//Noch zu schreibende Bytes
 unsigned long i;   //Allgemeiner Schleifenindex
 unsigned long count; //Lnge der Zeile beim Schreiben
 unsigned long checksum; //Checksumme der HEX-Zeile
 unsigned long hexbytes; //insgesamt geschriebene Datenbytes
 unsigned char check;    //Hilfsvariable
 unsigned long ffcount;  //Zeilen nur mit 0xFF nicht speichern
 unsigned char by;		 //Hilfsvariable
 char buff[ARRAYSIZE]; //Zeichenpuffer

 hexbytes=0;
 adr=start;
 rest=len; //Anzahl der zu schreibenden Datenbytes
 datadr=0; //Beginn bei dat[] Element 0

 do
  {
	if(adr<0x10000)
	 {
	  strcpy(buff,"S1");   //Kennung 16Bit Adresse
	  if(rest>=hexlen)
		{
		 // Daten+16Bit Adresse + Checksumme
		 sprintf(zeile,"%02lX",hexlen+3);
		 strcat(buff,zeile); 		//Anzahl aller Bytes der Zeile
		 checksum=hexlen+3; //gehrt zur Checksumme
		 count=hexlen;        //Anzahl zu schreibender Bytes
		}
	  else //Weniger als HEXLIN_LEN Datenbytes
		{
		 // Daten+16Bit Adresse + Checksumme
		 sprintf(zeile,"%02lX",rest+3);
		 strcat(buff,zeile);
		 checksum=rest+3;                //siehe oben
		 count=rest;
		}
	  sprintf(zeile,"%04lX",adr);    //Adresse eintragen
	  strcat(buff,zeile);
	  check=(unsigned char)(adr&0xFF); //Low und Highbyte zur Checksumme addieren
	  checksum+=check;
	  check=(unsigned char)((adr>>8)&0xFF);
	  checksum+=check;
	 } //Ende S1

	//Anfang S2
	if((adr>0xFFFF)&&(adr<0x1000000))
	 {
	  strcpy(buff,"S2"); //Kennung 24Bit Adresse
	  if(rest>=hexlen)
		{
		 // Daten+24Bit Adresse + Checksumme
		 sprintf(zeile,"%02lX",hexlen+4);
		 strcat(buff,zeile); 		//Anzahl aller Bytes der Zeile
		 checksum=hexlen+4; //gehrt zur Checksumme
		 count=hexlen;        //Anzahl zu schreibender Bytes
		}
	  else //Weniger als HEXLIN_LEN Datenbytes
		{
		 // Daten+24Bit Adresse + Checksumme
		 sprintf(zeile,"%02lX",rest+4);
		 strcat(buff,zeile);
		 checksum=rest+4;                //siehe oben
		 count=rest;
		}

	  sprintf(zeile,"%06lX",adr);    //Adresse eintragen
	  strcat(buff,zeile);
	  check=(unsigned char)(adr&0xFF); //Adresse zur Checksumme addieren
	  checksum+=check;
	  check=(unsigned char)((adr>>8)&0xFF);
	  checksum+=check;
	  check=(unsigned char)((adr>>16)&0xFF);
	  checksum+=check;
	 } //Ende S2

	//Anfang S3
	if(adr>0xFFFFFF)
	 {
	  strcpy(buff,"S3"); //Kennung 32Bit Adresse
	  if(rest>=hexlen)
		{
		 // Daten+32Bit Adresse + Checksumme
		 sprintf(zeile,"%02lX",hexlen+5);
		 strcat(buff,zeile); 		//Anzahl aller Bytes der Zeile
		 checksum=hexlen+5; //gehrt zur Checksumme
		 count=hexlen;        //Anzahl zu schreibender Bytes
		}
	  else //Weniger als HEXLIN_LEN Datenbytes
		{
		 // Daten+32Bit Adresse + Checksumme
		 sprintf(zeile,"%02lX",rest+5);
		 strcat(buff,zeile);
		 checksum=rest+5;                //siehe oben
		 count=rest;
		}

	  sprintf(zeile,"%08lX",adr);    //Adresse eintragen
	  strcat(buff,zeile);
	  check=(unsigned char)(adr&0xFF); //Adresse zur Checksumme addieren
	  checksum+=check;
	  check=(unsigned char)((adr>>8)&0xFF);
	  checksum+=check;
	  check=(unsigned char)((adr>>16)&0xFF);
	  checksum+=check;
	  check=(unsigned char)((adr>>24)&0xFF);
	  checksum+=check;
	 } //Ende S3

//Datenbytes einfgen
	ffcount=0; //Keine Zeilen mit Leerzellen schreiben

	for(i=0; i<count; i++)
	 {
	  by=dat[datadr+i]; //Datenbyte im Array
	  checksum+=by; // Alle Datenbytes in der Checksumme enthalten
	  sprintf(zeile,"%02X",by);
	  strcat(buff,zeile);
	  if(by==0xFF) ffcount++;
	  hexbytes++;       //Datenzhler fr Kontrolle
	 }

	checksum=~checksum; //Einerkomplement der Checksumme
	check=(unsigned char)(checksum&0xFF); //Nur das Lowbyte
	sprintf(zeile,"%02X\n",check); //Wandeln in ASCII
	strcat(buff,zeile);            //An die Zeile anhngen

	if(ffcount<hexlen) //Zeilen nur mit "FF"-Daten nicht schreiben
	 { result=fwrite(buff,strlen(buff),1,out); //Die ganze Zeile schreiben
		if(result==0) //darf nicht 0 sein weil Daten da waren
		 { NoHexLine(); return hexbytes; }
	 }
	else
	 {
	  if(no_ff>0) //Auch Zeilen nur mit "FF"-Daten schreiben
		{ result=fwrite(buff,strlen(buff),1,out); //Die ganze Zeile schreiben
		  if(result==0) //darf nicht 0 sein weil Daten da waren
			{ NoHexLine(); return hexbytes; }
		}
	 }

	adr+=hexlen;    //Neuer Offset im EPROM
	datadr+=hexlen; //Neuer Offset im Array
	if(rest>=hexlen) rest-=hexlen;
	else rest=0; //Geschriebene Bytes abziehen

  }while(rest>0);

 return hexbytes;
}